--------------------------------------------------------------------------------
-- Copyright (c) 1995-2011 Xilinx, Inc.  All rights reserved.
--------------------------------------------------------------------------------
--   ____  ____ 
--  /   /\/   / 
-- /___/  \  /    Vendor: Xilinx 
-- \   \   \/     Version : 13.4
--  \   \         Application : sch2hdl
--  /   /         Filename : Prac4_Part1a_2012.vhf
-- /___/   /\     Timestamp : 03/19/2012 16:48:25
-- \   \  /  \ 
--  \___\/\___\ 
--
--Command: sch2hdl -intstyle ise -family spartan3e -flat -suppress -vhdl H:/e3004_2012/Prac4_Part1a_2012/Prac4_Part1a_2012.vhf -w H:/e3004_2012/Prac4_Part1a_2012/Prac4_Part1a_2012.sch
--Design Name: Prac4_Part1a_2012
--Device: spartan3e
--Purpose:
--    This vhdl netlist is translated from an ECS schematic. It can be 
--    synthesized and simulated, but it should not be modified. 
--

library ieee;
use ieee.std_logic_1164.ALL;
use ieee.numeric_std.ALL;
library UNISIM;
use UNISIM.Vcomponents.ALL;

entity Prac4_Part1a_2012 is
   port ( AD1_D1   : in    std_logic; 
          AD1_D2   : in    std_logic; 
          clk50mhz : in    std_logic; 
          RESET    : in    std_logic; 
          SlideSW0 : in    std_logic; 
          AD1_CLK  : out   std_logic; 
          AD1_CS   : out   std_logic; 
          DA1_CLK  : out   std_logic; 
          DA1_D1   : out   std_logic; 
          DA1_D2   : out   std_logic; 
          DA1_SYNC : out   std_logic; 
          LEDs0    : out   std_logic; 
          LEDs1    : out   std_logic; 
          LEDs3    : out   std_logic; 
          XLXN_7   : out   std_logic);
end Prac4_Part1a_2012;

architecture BEHAVIORAL of Prac4_Part1a_2012 is
   attribute BOX_TYPE   : string ;
   attribute IOSTANDARD : string ;
   attribute SLEW       : string ;
   attribute DRIVE      : string ;
   signal ADChan1        : std_logic_vector (11 downto 0);
   signal ADChan2        : std_logic_vector (11 downto 0);
   signal FilterOut      : std_logic_vector (11 downto 0);
   signal Filter1        : std_logic_vector (11 downto 0);
   signal MuxOut         : std_logic_vector (11 downto 0);
   signal SampleClock    : std_logic;
   signal XLXN_9         : std_logic;
   signal XLXN_15        : std_logic;
   signal XLXN_16        : std_logic;
   signal DA1_SYNC_DUMMY : std_logic;
   signal XLXN_7_DUMMY   : std_logic;
   component clockdiv1
      port ( clkin  : in    std_logic; 
             clkout : out   std_logic);
   end component;
   
   component BUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute BOX_TYPE of BUF : component is "BLACK_BOX";
   
   component DAC_CTRL
      port ( SCLK  : in    std_logic; 
             CLK   : in    std_logic; 
             DONE  : in    std_logic; 
             SYNC  : in    std_logic; 
             START : out   std_logic);
   end component;
   
   component AD1RefComp
      port ( CLK    : in    std_logic; 
             RST    : in    std_logic; 
             SDATA1 : in    std_logic; 
             SDATA2 : in    std_logic; 
             START  : in    std_logic; 
             SCLK   : out   std_logic; 
             nCS    : out   std_logic; 
             DONE   : out   std_logic; 
             DATA1  : out   std_logic_vector (11 downto 0); 
             DATA2  : out   std_logic_vector (11 downto 0));
   end component;
   
   component DA2RefComp
      port ( CLK     : in    std_logic; 
             RST     : in    std_logic; 
             START   : in    std_logic; 
             DATA1   : in    std_logic_vector (11 downto 0); 
             DATA2   : in    std_logic_vector (11 downto 0); 
             D1      : out   std_logic; 
             D2      : out   std_logic; 
             CLK_OUT : out   std_logic; 
             nSYNC   : out   std_logic; 
             DONE    : out   std_logic);
   end component;
   
   component OBUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
   attribute IOSTANDARD of OBUF : component is "DEFAULT";
   attribute SLEW of OBUF : component is "SLOW";
   attribute DRIVE of OBUF : component is "12";
   attribute BOX_TYPE of OBUF : component is "BLACK_BOX";
   
   component Echo_IIR_1
      port ( SAMPLECLK : in    std_logic; 
             DATAIN    : in    std_logic_vector (11 downto 0); 
             DATAOUT   : out   std_logic_vector (11 downto 0));
   end component;
   
   component Echo_IIR_2_B
      port ( SAMPLECLK : in    std_logic; 
             DATAIN    : in    std_logic_vector (11 downto 0); 
             DATAOUT   : out   std_logic_vector (11 downto 0));
   end component;
   
   component ADC_Mux
      port ( Selector : in    std_logic; 
             ADChan1  : in    std_logic_vector (11 downto 0); 
             ADChan2  : in    std_logic_vector (11 downto 0); 
             ADMuxOut : out   std_logic_vector (11 downto 0));
   end component;
   
begin
   DA1_SYNC <= DA1_SYNC_DUMMY;
   XLXN_7 <= XLXN_7_DUMMY;
   XLXI_2 : clockdiv1
      port map (clkin=>clk50mhz,
                clkout=>SampleClock);
   
   XLXI_6 : BUF
      port map (I=>DA1_SYNC_DUMMY,
                O=>XLXN_15);
   
   XLXI_7 : BUF
      port map (I=>XLXN_7_DUMMY,
                O=>XLXN_16);
   
   XLXI_11 : DAC_CTRL
      port map (CLK=>clk50mhz,
                DONE=>XLXN_16,
                SCLK=>SampleClock,
                SYNC=>XLXN_15,
                START=>XLXN_9);
   
   XLXI_18 : AD1RefComp
      port map (CLK=>clk50mhz,
                RST=>RESET,
                SDATA1=>AD1_D1,
                SDATA2=>AD1_D2,
                START=>XLXN_9,
                DATA1(11 downto 0)=>ADChan1(11 downto 0),
                DATA2(11 downto 0)=>ADChan2(11 downto 0),
                DONE=>LEDs1,
                nCS=>AD1_CS,
                SCLK=>AD1_CLK);
   
   XLXI_32 : DA2RefComp
      port map (CLK=>clk50mhz,
                DATA1(11 downto 0)=>FilterOut(11 downto 0),
                DATA2(11 downto 0)=>Filter1(11 downto 0),
                RST=>RESET,
                START=>XLXN_9,
                CLK_OUT=>DA1_CLK,
                DONE=>XLXN_7_DUMMY,
                D1=>DA1_D1,
                D2=>DA1_D2,
                nSYNC=>DA1_SYNC_DUMMY);
   
   XLXI_33 : OBUF
      port map (I=>SampleClock,
                O=>LEDs3);
   
   XLXI_34 : OBUF
      port map (I=>XLXN_9,
                O=>LEDs0);
   
   XLXI_37 : Echo_IIR_1
      port map (DATAIN(11 downto 0)=>Filter1(11 downto 0),
                SAMPLECLK=>SampleClock,
                DATAOUT(11 downto 0)=>FilterOut(11 downto 0));
   
   XLXI_38 : Echo_IIR_2_B
      port map (DATAIN(11 downto 0)=>MuxOut(11 downto 0),
                SAMPLECLK=>SampleClock,
                DATAOUT(11 downto 0)=>Filter1(11 downto 0));
   
   XLXI_47 : ADC_Mux
      port map (ADChan1(11 downto 0)=>ADChan1(11 downto 0),
                ADChan2(11 downto 0)=>ADChan2(11 downto 0),
                Selector=>SlideSW0,
                ADMuxOut(11 downto 0)=>MuxOut(11 downto 0));
   
end BEHAVIORAL;


